<template>
    <div class="app">
        <vue-headful
            title = "Needoc Perfil"
            description = "Perfil del usuario"
        />
        <div  class="sect-header margin-bot2">
            <h1>
                bienvenido a tu <span class="color-prime">perfil
                <br>
                {{ username }}</span>
            </h1>
        </div>
        <userprofile v-on:updateEmit="updateUserProfile" :userprofile="userprofileAPI" />

    </div>
</template>


<script>
import axios from 'axios';
import { getID } from '../../../backend/utils/utils'
import { getAuthToken } from '../../../backend/utils/utils'
import { getName } from '../../../backend/utils/utils' // traemos el nombre de usuario para el titulo

import userprofile from '@/components/UserProfileCustom.vue';

export default {
    name: 'profileUser',
 
    // inicio componente
    components: {
        userprofile
    },
    // FIN componente
    // inicio data
    data(){
        return{

            userprofileAPI: [],
            name:'',
            surname:'',
            username:'',
            email:'',
        }
    },
    // FIN data
    // inicio Methods
    methods: {

        // Traemos el name para insertar en el titulo
        setUserName(){
            this.username = getName()
            },

        // Función para conseguir los datos del usuario
        getUserProfile(response){

            var self = this;
            // inicio codigo temporal
             axios.get(`http://localhost:3050/user/${getID()}`, {
                headers:{
                     Authorization: getAuthToken()
                }
            })
            // fin codigo temporal
            .then( function(response) {

                self.userprofileAPI = response.data

            } )
            .catch( function(error) {
                console.log(error)
            } )
        },
        
        // Fin getUserProfile()

         // Función para modificar los datos del usuario
         updateUserProfile(name, surname, email){
            var self = this;
            // axios.get('http://localhost:3050/user/:id', {
            // inicio codigo temporal
             axios.patch(`http://localhost:3050/user/${getID()}`, {

                    name,
                    surname,
                    email

                },  {
                headers:{
                     Authorization:  getAuthToken()
                },
            })
            // fin codigo temporal
            .then( function(response) {
                
                self.userprofileAPI = response.data.data
                
                location.reload() // recargar la pagina para quitar error

            } )
            .catch( function(error) {
                console.log(error)
            } )
        }
        // Fin updateUserProfile()
    },
    // FIN methods
    created(){
        this.getUserProfile(); // obtener datos
        this.setUserName() // traer nombre

        // this.updateUserProfile(this.name, this.surname); // modificar datos
    }
}
</script>

<style scoped>
.sect-header {
    padding: 0 5rem;
}
</style>